Program SaveGrab;
uses dos;
type
                 PCXHeader = record
              Manufacturer : Byte;
                   Version : Byte;
                  Encoding : Byte;
              BitsPerPixel : Byte;
                      xMin : Word;
                      yMin : Word;
                      xMax : Word;
                      yMax : Word;
                 Hdpi,Vdpi : Word;
                   Palette : Array[0..47] of Byte;
                  Reserved : Byte; {0}
               ColorPlanes : Byte;
              BytesPerLine : Word;
               PaletteInfo : Word;
               HScreenSize : Word;
               VScreenSize : Word;
                    Filler : Array[0..53] of Byte;
                          End;

                        BA = Array[0..65520] of Byte;
                     BAPtr = ^BA; { Beer Academy? ;> Glg glg! }

const
                         O = $00;
                         L = $A8;
                         Z = $54;
                         Q = $FC;

                   fHeader : PCXHeader =
             (Manufacturer : $0A;
                   Version : $05;
                  Encoding : $01;
              BitsPerPixel : $08;  { Strange format, but should work }
                      xMin : $0000;
                      yMin : $0000;
                      xMax : $009F; { 160 pixels wide }
                      yMax : $00C7; { 200 pixels tall }
                      HDpi : $0024; { 36 DPI (half of normal) }
                      VDpi : $0048; { 72 DPI (normal) }
                   Palette : (O,O,O, O,O,L, O,L,O, O,L,L,
                              L,O,O, L,O,L, L,L,O, L,L,L,
                              Z,Z,Z, Z,Z,Q, Z,Q,Z, Z,Q,Q,
                              Q,Z,Z, Q,Z,Q, Q,Q,Z, Q,Q,Q);
                  Reserved : 0;
               ColorPlanes : $01; { VGA mode13h- like }
              BytesPerLine : $A0;
               PaletteInfo : $0001;
               HScreenSize : $00A0;
               VScreenSize : $00C8;
                    Filler : (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                              0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0));


var FileName:String;
           f:File;

         Pal:Array[0..769] of Byte;

         Buf:Array[0..16383] of Byte;
           i:Word;

     DoubleW:Boolean;

         x,y:Word;
     Rep,Dat:Word;
           u:BAPtr;


Function GetPixel(xC,yC:Integer):Byte;
var Addr:Word;
 Begin
  Addr:=4+(xC shr 1)+(yC and 1) shl 13 + (yC shr 1)*80;
  if (xC and 1)=0 then GetPixel:=(u^[Addr] shr 4) and 15
                  else GetPixel:=(u^[Addr] and 15);
 End;

Procedure Out(Count,Data:Word);
 Begin
  if (Count>1) or (Data>191) then Begin
     Buf[i]:=Count+192;inc(i);End;
  Buf[i]:=Data;inc(i);if (i>12287) then Begin;blockwrite(f,buf,i);i:=0;End;
 End;


Begin
 writeln(output,'Crappy Grabber! (C) .. I better not tell to save my reputation!');
 if paramcount>0 then FileName:=ParamStr(1) else Begin
   Writeln(Output,'SaveGrab <tofile[.PCX]> [/d]');
   writeln(output,'/d gives "stretched"; 320x200 picture.');
   halt;
  End;
 DoubleW:=False;if paramcount>1 then
  if (copy(paramstr(2),1,2)='/d') or (copy(paramStr(2),1,2)='/D') then DoubleW:=True;
 getIntVec($A2,pointer(u));
 if (u^[0]<>$CF) or (u^[1]<>byte('P')) or
    (u^[2]<>byte('i')) or (u^[3]<>byte('c')) then Begin
     Writeln(Output,'Grab header cannot be found = StarGrab is not loaded?');
     halt;
    End;
 if pos('.',FileName)=0 then FileName:=FileName+'.PCX';
 FillChar(Pal,769,0);
 for x:=0 to 47 do Pal[x]:=fHeader.palette[x];
 Assign(f,FileName);rewrite(f,1);
 if IOResult<>0 then Begin
   Writeln(Output,FileName,': Invalid file name!');
  Halt;
  End;
 Writeln(Output,'Storing grabbed data to ',FileName,' ..');
 if not DoubleW then Begin
   blockwrite(f,fHeader,128);i:=0;
   for y:=0 to 199 do Begin
    Rep:=1;Dat:=Getpixel(0,y);x:=1;
    While(x<160) do Begin
     if (rep<63) and (dat=Getpixel(x,y)) then Begin;inc(x);inc(rep);end else
     Begin
      out(Rep,Dat);Rep:=1;Dat:=Getpixel(x,y);inc(x);
     End;
    End;
    Out(Rep,Dat);
   End;
   buf[i]:=12;inc(i);Blockwrite(f,buf,i);
 End else Begin
   fHeader.xMax:=319;fHeader.BytesPerLine:=320;fHeader.hScreenSize:=320;
   fHeader.hdpi:=72;
   blockwrite(f,fHeader,128);i:=0;
   for y:=0 to 199 do Begin
    Rep:=2;Dat:=Getpixel(0,y);x:=1;
    While(x<160) do Begin
     if (rep<62) and (dat=Getpixel(x,y)) then Begin;inc(x);inc(rep,2);end else
     Begin
      out(Rep,Dat);Rep:=2;Dat:=Getpixel(x,y);inc(x);
     End;
    End;
    Out(Rep,Dat);
   End;
   buf[i]:=12;inc(i);Blockwrite(f,buf,i);
 End;
 blockWrite(f,pal,768);
 close(f);
End.

{ Comment :

  Oh god, I'm stupid. I wondered for three hours, why the palette was
  screwed up. I tried loading it from DAC during capture. Still wrong.
  I did helluva lot of debugging, but didn't find any bugs. Then I
  debugged one .PCX file, and found it: I originally copied the first
  sixteen entries over the entire palette. I had written AND 47 where
  I should've written mod 47. Ok, it's quite innocent bug (and/mod..
  I mix'em quite easily) .. But I did not even need it anymore.
  Oh damn. And its past four in the morning ..

}
